'FFSubmenu=CD-VCD-SVCD
'FFName=VCD Prepare
'FFPath=vcdprepare.vbs
'
' vcdprepare.vbs
'*********************************************************
' VCD Prepare V2.3
' (C) Zaph 2003-2004
' Email: zaphl@gmx.de
'
' nur ablauffhig mit Fixfoto V2.76
' Fixfoto: http://www.j-k-s.com
'*********************************************************
'
' VCD Prepare erzeugt aus den selektierten Bildern neue Bilder
' im VCD-Format zum Umwandeln und Brennen fr eine Video oder
' Super-Video-CD (Standbild VCD 2.0/SVCD 704x576) oder DVD-Format
' Als Parameter werden Korrekturfaktoren eingegeben, um
' 1. Verzerrungen auszugleichen, die durch VCD/DVD-Player und Fernsehgert entstehen
' 2. eine vollstndige (nicht abgeschnittene) Darstellung auf dem Bildschirm zu ermglichen
' Die Parameter werden in einem Meverfahren mit Hilfe eines Mebildes ermittelt
' (Teil der Installation von VCD Prepare)
' Nhere Hinweise zum Programme und zum Meverfahren siehe Dokumenation zum Programm
'
' nderungen:
' V2.1:	DVD-Format, einblendbares Datum
' V2.2:	Bug in Versionsabfrage gefixt
' V2.3: Bug in Exifdatum anzeigen gefixt, automatische Konfiguration

Option Explicit

Const dlgVP = "VCD Prepare 2.3 (C)Zaph 2004"

' Globale Variable:
' a: Abweichung in % vom linken Rand
' b: Abweichung in % vom rechten Rand
' c: Abweichung in % vom unteren Rand
' d: Abweichung in % vom oberen Rand
Dim a,b,c,d
' mx: Durchmesser des Messkreises in waagerechter Richtung
' my: Durchmesser des Messkreises in senkrechter Richtung
' Einheiten in mm
Dim mx, my
' zielpfad: Verzeichnis, in dem die erzeugten Bilder abgelegt werden
' framecol: Rahmenfarbe im Format "RRR GGG BBB"
' setfile: Name des Parameterfiles
Dim zielpfad, framecol, setfile
' format: Zielformat der Bilder VCD oder VCD gestaucht, DVD
Dim format
' fcol: Rahmenfarbe im Integerformat
Dim fcol
' btext: Datum einblenden
Dim btext
' INI-Datei fr Einstellungen (im Windows-Verzeichnis)
Dim vcdini

const VCDo = "VCD"
const VCDg = "VCD gestaucht"
const DVD = "DVD"

Call Main

sub Main
	' Version checken
	if not CheckBuild("2.76.00") then
		msgbox "Dieses Script luft erst ab FF Version 2.76 - Abbruch!", vbCritical, "VCDPrepare"
		exit sub
	end if

	' Bilder markiert?
	if FF_GetImageCount = 0 then
		msgbox "Keine Bilder zum Bearbeiten markiert - Abbruch!", vbCritical, "VCDPrepare"
		exit sub
	end if

	vcdini = VcdIniPath

	' Aufruf des Mens
	Call Menu
end sub
' Ende Hauptprogramm

'*********************************************************
' Aufbau, Anzeige und Auswertung der Eingabemaske
'*********************************************************
Sub Menu
	Const cmdOK = "OK"
	Const cmdCancel = "Abbrechen"
	Const cmdZv = "..."
	Const cmdSave = "Parametersatz speichern"
	Const cmdLoad = "Parametersatz laden"
	Const WS_TABSTOP = &H10000

	dim ok, dialogEnde
	Dim fx,fy,dfx,dfy,fh,dw,dh
	Dim dirc,file,ext,pfad

	' Defaultwerte
	a = "0"
	b = "0"
	c = "0"
	d = "0"
	mx = "1"
	my = "1"
	framecol = "000 000 000"
	zielpfad = ""
	setfile = ""
	format = VCDg
	btext = "0"

	' Defaultwerte ggf. mit letzten Einstellungen berschreiben
	Call ReadVcdIni

	' Fensterabmessungen
	dw = 210
	dh = 180
	' linke obere Ecke im Dialogfenster
	fx = 10
	fy = 10
	' Abstand zwischen zwei Dialogzeilen
	dfy = 15
	' Hhe einer Dialogzeile
	fh = 10

	' Dialog ffnen
	FF_AddDialog dlgVP, dw, dh

	' Parameterblock
	FF_AddControl dlgVP, "Parameter", "GROUP", 5 , 5, 200, 82
	fy = fy + 2
	FF_AddControl dlgVP, "Parametersatz", "STATIC", fx, fy, 38, fh
	FF_AddControl dlgVP, "txtSet", "EDIT", fx+40, fy, 150, fh
	If setfile <> "" Then
		SplitPath setfile, dirc, file, ext
		FF_SetControl dlgVP, "txtSet", file & ext
	End If
	FF_EnableControl dlgVP, "txtSet", false
	fy = fy + dfy
	FF_AddControl dlgVP, "A [%]", "STATIC", fx, fy, 20, fh
	FF_AddControl dlgVP, "txtA", "EDIT", fx+25, fy, 20, fh
	FF_SetControl dlgVP, "txtA", a
	FF_AddControl dlgVP, "B [%]", "STATIC", fx+60, fy, 20, fh
	FF_AddControl dlgVP, "txtB", "EDIT", fx+85, fy, 20, fh
	FF_SetControl dlgVP, "txtB", b
	fy = fy + dfy
	FF_AddControl dlgVP, "C [%]", "STATIC", fx, fy, 20, fh
	FF_AddControl dlgVP, "txtC", "EDIT", fx+25, fy, 20, fh
	FF_SetControl dlgVP, "txtC", c
	FF_AddControl dlgVP, "D [%]", "STATIC", fx+60, fy, 20, fh
	FF_AddControl dlgVP, "txtD", "EDIT", fx+85, fy, 20, fh
	FF_SetControl dlgVP, "txtD", d
	fy = fy + dfy
	FF_AddControl dlgVP, "MX [mm]", "STATIC", fx, fy, 20, fh
	FF_AddControl dlgVP, "txtMx", "EDIT", fx+25, fy, 20, fh
	FF_SetControl dlgVP, "txtMx", mx
	FF_AddControl dlgVP, "MY [mm]", "STATIC", fx+60, fy, 20, fh
	FF_AddControl dlgVP, "txtMy", "EDIT", fx+85, fy, 20, fh
	FF_SetControl dlgVP, "txtMy", my
	fy = fy + dfy
	FF_AddControl dlgVP, cmdSave, "BUTTON", fx, fy, 70, fh
	FF_AddControl dlgVP, cmdLoad, "BUTTON", fx+80, fy, 70, fh

	' Einstellungsblock
	fy = fy + 20
	FF_AddControl dlgVP, "Einstellungen", "GROUP", 5 , fy , 200, 70
	fy = fy + 10
	FF_AddControl dlgVP, "Zielverzeichnis", "STATIC", fx, fy, 40, fh
	FF_AddControl dlgVP, "txtZv", "EDIT", fx+40, fy, 135, fh
	FF_SetControl dlgVP, "txtZv", zielpfad
	FF_AddControl dlgVP, cmdZv, "BUTTON", fx+180, fy, 10, fh
	fy = fy + dfy
	FF_AddControl dlgVP, "Rahmenfarbe", "STATIC", fx, fy, 40, fh
	FF_AddControl dlgVP, "txtCol", "COLOR", fx+40, fy, 20, fh
	FF_SetControl dlgVP, "txtCol", framecol
	fy = fy + dfy
	FF_AddControl dlgVP, "Format", "STATIC", fx, fy, 40, fh
	FF_AddControl dlgVP, "cboFormat", "COMBO", fx+40, fy, 50, fh
	FF_SetControl dlgVP, "cboFormat", VCDo
	FF_SetControl dlgVP, "cboFormat", VCDg
	FF_SetControl dlgVP, "cboFormat", DVD
	FF_SetControl dlgVP, "cboFormat", format
	FF_SetControlStyle dlgVP, "cboFormat", WS_TABSTOP
	fy = fy + dfy
	FF_AddControl dlgVP, "Datum einfgen", "STATIC", fx, fy, 38, fh
	FF_AddControl dlgVP, "blnText", "BOOL", fx+40, fy, 10, fh
	FF_SetControl dlgVP, "blnText", bText

	' OK, Cancel
	FF_AddControl dlgVP, cmdOK, "BUTTON", dw-90, dh-13, 40, fh
	FF_AddControl dlgVP, cmdCancel, "BUTTON", dw-45, dh-13, 40, fh

	' solange Dialog anzeigen, bis "OK" oder "Abbrechen" gedrckt wurde
	dialogEnde = false
	do
		' Dialog ffnen
		select case FF_ShowDialog(dlgVp)

		' Knopf "Zielverzeichnis" ("...") gedrckt
		case cmdZv
			pfad = FF_EnterPath(false, "Zielverzeichnis auswhlen")
			if pfad <> "" then zielpfad = pfad
			FF_SetControl dlgVP, "txtZv", zielpfad
			FF_ActivateControl dlgVP, "txtZv"

		' Knopf "Parametersatz speichern" gedrckt
		case cmdSave
			call readFields
			ok = SaveParams
			SplitPath setfile, dirc, file, ext
			FF_SetControl dlgVP, "txtSet", file & ext

		' Knopf "Parametersatz laden" gedrckt
		case cmdLoad
			ok = LoadParams
			SplitPath setfile, dirc, file, ext
			FF_SetControl dlgVP, "txtSet", file & ext
			FF_SetControl dlgVP, "txtA", a
			FF_SetControl dlgVP, "txtB", b
			FF_SetControl dlgVP, "txtC", c
			FF_SetControl dlgVP, "txtD", d
			FF_SetControl dlgVP, "txtMx", mx
			FF_SetControl dlgVP, "txtMy", my

		' Kopf "OK" gedrckt" => Check
		case cmdOK
		If not FolderExists(zielpfad) then
			msgbox "Zielverzeichnis " & zielpfad & " existiert nicht ... bitte neu auswhlen!", vbCritical, "VCD Prepare"
		else
			' Eingabe(n) auswerten
			call readFields
			dialogEnde = True
		End If

		' Bei "Abbrechen" Programm beenden
		case cmdCancel
			FF_CloseDialog dlgVP
			exit sub

		end select

	loop until dialogEnde

	' Dialog schliessen
	FF_CloseDialog dlgVP

	' Einstellungen abspeichern
	Call SaveVcdIni

	' Eingabeparameter umsetzen
	a = cdbl(a)
	b = cdbl(b)
	c = cdbl(c)
	d = cdbl(d)
	fcol = split(framecol," ",-1)

	' Verarbeitung der selektierten Bilder
	Call ProcessPics
End Sub

'*********************************************************
' Feldinhalte auslesen und in globale Variablen schreiben
'*********************************************************
sub readFields
	a = FF_GetControl(dlgVP, "txtA")
	b = FF_GetControl(dlgVP, "txtB")
	c = FF_GetControl(dlgVP, "txtC")
	d = FF_GetControl(dlgVP, "txtD")
	mx = FF_GetControl(dlgVP, "txtMx")
	my = FF_GetControl(dlgVP, "txtMy")
	framecol = FF_GetControl(dlgVP, "txtCol")
	format = FF_GetControl(dlgVP, "cboFormat")
	zielpfad = FF_GetControl(dlgVP, "txtZv")
	btext = FF_GetControl(dlgVP, "blnText")
end sub

'*********************************************************
' checkt die aktuelle Version gegen eine minimal geforderte
' Version
' In:
' refBuild: Major.Minor.Build
' z.B.: "2.71.31"
' Out:
' CheckBuild: true oder false
'*********************************************************
function CheckBuild(refBuild)
	dim refver, aktver(2), i
	refver = split(refBuild,".",-1)
	for i=0 to 2
		refver(i) = cint(refver(i))
	next
	On Error Resume Next
	aktver(0) = FF_GetMajor()
	if err.number then
		CheckBuild = false
		exit function
	end if
	On Error goto 0
	aktver(1) = FF_GetMinor()
	aktver(2) = FF_GetBuild()
	if aktver(0) > refver(0) then
		CheckBuild = true
		exit function
	elseif aktver(0) = refver(0) then
		if aktver(1) > refver(1) then
			CheckBuild = true
			exit function
		elseif aktver(1) = refver(1) then
			if aktver(2) >= refver(2) then
				CheckBuild = true
				exit function
			end if
		else
			CheckBuild = false
			exit function
		end if
	else
		CheckBuild = false
		exit function
	end if
end function

'*********************************************************
' ermittelt den Pfad und Dateinamen der INI-Datei
'*********************************************************
Function VcdIniPath
	dim wsh, path
	Set wsh = CreateObject ("WScript.Shell")
	path = wsh.ExpandEnvironmentStrings("%windir%")
	VcdIniPath = path & "\vcdprepare.ini"
	set wsh = nothing
End Function

'*********************************************************
' INI-Datei auslesen und in die globalen Variablen
' eintragen
'*********************************************************
Sub ReadVcdIni
	Const ForReading = 1, ForWriting = 2
	Dim fso, IniFile, ok
	Set fso = CreateObject("Scripting.FileSystemObject")
	if fso.FileExists(vcdini) then
		On Error Resume Next
		Set IniFile = fso.OpenTextFile(vcdini, ForReading)
		zielpfad = IniFile.ReadLine
		setfile = IniFile.ReadLine
		framecol = IniFile.ReadLine
		format = IniFile.ReadLine
		btext = IniFile.ReadLine
		On Error Goto 0
		ok = ReadParams(setfile)
	End If
	set fso = nothing
End Sub

'*********************************************************
' Werte der globalen Variablen in die INI-Datei schreiben
'*********************************************************
Sub SaveVcdIni
	Const ForReading = 1, ForWriting = 2
	Dim fso, IniFile
	Set fso = CreateObject("Scripting.FileSystemObject")
	Set IniFile = fso.OpenTextFile(vcdini, ForWriting, True)
	IniFile.WriteLine zielpfad
	IniFile.WriteLine setfile
	IniFile.WriteLine framecol
	IniFile.WriteLine format
	IniFile.WriteLine btext
	IniFile.Close
	set fso = nothing
End Sub

'*********************************************************
' Parameterwerte in eine SET-Datei schreiben
'*********************************************************
Function SaveParams
	Dim fso, SF, sel, file
	SaveParams = False
	Set fso = CreateObject("Scripting.FileSystemObject")
	If setfile = "" Then
		sel = FF_GetFFPath & "\*.set"
	Else
		sel = setfile
	End If
	file = FF_EnterFileName(false, sel)
	If file = "" Then Exit Function
	setfile = file
	Set SF = fso.CreateTextFile(setfile, True)
	SF.WriteLine a
	SF.WriteLine b
	SF.WriteLine c
	SF.WriteLine d
	SF.WriteLine mx
	SF.WriteLine my
	SF.Close
	SaveParams = True
	set fso = nothing
End Function

'*********************************************************
' SET-Datei selektieren und auslesen
'*********************************************************
Function LoadParams
	Dim sel, dirc, file, ext
	LoadParams = False
	If setfile = "" Then
		sel = FF_GetFFPath & "\*.set"
	Else
		SplitPath setfile, dirc, file, ext
		sel = dirc & "*.set"
	End If
	file = FF_EnterFileName(true, sel)
	if file = "" Then Exit Function
	setfile = file
	LoadParams = ReadParams(setfile)
End Function

'*********************************************************
' Parameterwerte aus SET-Datei auslesen
'*********************************************************
Function ReadParams(setfile)
	Const ForReading = 1, ForWriting = 2
	Dim fso, SF
	ReadParams = False
	Set fso = CreateObject("Scripting.FileSystemObject")
	if Not fso.FileExists(setfile) then Exit Function
	Set SF = fso.OpenTextFile(SetFile, ForReading)
	a = SF.ReadLine
	b = SF.ReadLine
	c = SF.ReadLine
	d = SF.ReadLine
	mx = SF.ReadLine
	my = SF.ReadLine
	SF.Close
	set fso = nothing
	ReadParams = True
End Function

'*********************************************************
' Verarbeitung aller selektierten Bilder
' Bilder werden umbenannt in "VCD_Bildname"
' Speicherung im Verzeichnis zielpfad
'*********************************************************
Sub ProcessPics
	Dim path,dirc,file,ext
	Dim imagenum, i

	imagenum = FF_GetImageCount
	For i=0 to imagenum-1
		If imagenum > 1 Then
			Call FF_SetProgress(i, imagenum)
		End If
		path = FF_GetImageName(i)
		SplitPath path,dirc,file,ext
		FF_LoadImage path
		Call ScaleAndFrame
		If zielpfad <> "" Then
			dirc = zielpfad & "\"
		End If
		Call FF_SaveImage(dirc & "VCD_" & file & ext,0)
	Next
	msgbox imagenum & " Bild(er) erzeugt in " & dirc, vbInformation, "VCD Prepare"
End Sub

'*********************************************************
' Berechnung der Verzerrung und der Bildrahmen
' Skalierung der Bilder und Hinzufgen der Rahmen
'*********************************************************
Sub ScaleAndFrame
	Dim Vxr, Vyr, Vxv, Vyv
	Dim Vx, Vy
	Dim lxn, lyn
	Dim Vkx, Vbx, Vby, Vpx, Vpy, Vb, Vxg, Vyg, Vg
	Dim orgx, orgy
	Dim Rx, Ry
	Dim da, db, dc, dd
	Dim nx, ny
	Dim dx, dy
	Dim lx, ly
	' lbx: reale Bildschirmauflsung VCD in Pixel, wird vom Fernseher gedehnt auf lx
	Dim lbx

	' Bildabmessungen 4:3 in Pixel
	select case format
	case VCDo
		lbx=768
		lx=768
	case VCDg
		lbx=704
		lx=768
	case DVD
		lbx=720
		lx=720
	end select
	ly=576

	' Auflsung des Quellbildes
	orgx = FF_GetImageWidth()
	orgy = FF_GetImageHeight()

	' Korrekturfaktor: Stauchung auf reale Bildschirmauflsung
	Vkx = lbx / lx

	' Berechnung des Verkleinerungsfaktors Vb fr das Quellbild
	Vpx = lx / orgx
	Vpy = ly / orgy
	Vb = Min(Vpx, Vpy)

	' Berechnung des Rahmens

	' Verkleinerungsfaktoren zur Berechnung der Bildschirmrnder=Korrektur von a,b,c,d
	Vxr = (100-a-b)/100
	Vyr = (100-c-d)/100

	' Verkleinerungsfaktoren bzgl. der Bildgeometrie (Kompensation von Verzerrungen)
	If mx>my Then
		Vxv = my/mx
		Vyv = 1
	Else
		Vxv = 1
		Vyv = mx/my
	End if

	'Ermittlung der effektiven Vergroesserungsfaktoren aus den Faktoren der Rnder und der Geometrie
	Vxg = Vxr / Vxv
	Vyg = Vyr / Vyv
	Vg = Min(Vxg,Vyg)

	Vx = Vxv * Vg
	Vy = Vyv * Vg

	' Effektive Quellbildvergroesserung mit allen Korrekturfaktoren
	Vbx = Vkx * Vb * Vx
	Vby = Vb * Vy

	' Neue Quellbildgrsse
	nx = round(orgx * Vbx)
	ny = round(orgy * Vby)

	' Skalierung des Bildes
	FF_HQScale nx, ny, False
	nx = FF_GetImageWidth()
	ny = FF_GetImageHeight()
	if btext = "1" then insertText nx, ny

	' Berechnung der Einzelrahmen da, db, dc, dd
	' Berechnung der Bildschirmrnder bzgl. Korrektur von a,b,c,d
	da = a/100 * lx
	db = b/100 * lx
	dc = c/100 * ly
	dd = d/100 * ly

	' Endgltige Rahmengren incl. Korrekturfaktor VCD-Stauchung
	dx = (lbx - nx - (da + db)*Vkx) / 2
	da = round(da + dx)
	db = lbx - da - nx
	dy = (ly - ny - dc - dd) / 2
	dc = round (dc + dy)
	dd = ly - dc - ny

	' Erweiterung des Rahmens
	FF_ExtendCanvas da, db, dd, dc, fcol(0), fcol(1), fcol(2)
End Sub

'*********************************************************
' Einfgen des Datums in das Bild
'*********************************************************
sub insertText(x, y)
	dim tx, ty
	dim text, colb, colf
	dim tag, dattim, dat, tim
	const th=20
	const tw=1000
	const FACE = "ARIAL"
	colb = rgb2int(0,0,0)
	colf = rgb2int(255,255,255)
	if not FF_HasExif() then Exit Sub
	tag = FF_GetExifTag("DateTimeOriginal")
	dattim = split(tag," ",-1)
	dat = split(dattim(0),":",-1)
	tim = split(dattim(1),":",-1)
	text = dat(2) & "." & dat(1) & "." & dat(0) & " " & tim(0) & ":" & tim(1)

	tx = (x-FF_GetTextWidth(text,th,tw,false,false,FACE))/2
	ty = y - FF_GetTextHeight(text,th,tw,false,false,FACE) - 5
	FF_DrawText text,tx+1,ty+1,th,0,tw,false,false,FACE,colb
	FF_DrawText text,tx+1,ty-1,th,0,tw,false,false,FACE,colb
	FF_DrawText text,tx-1,ty+1,th,0,tw,false,false,FACE,colb
	FF_DrawText text,tx-1,ty-1,th,0,tw,false,false,FACE,colb
	FF_DrawText text,tx,ty,th,0,tw,false,false,FACE,colf
end sub

'*********************************************************
' Integerwert eines RGB-Tripels
'*********************************************************
function rgb2int(r,g,b)
	rgb2int = r+g*256+b*65536
end function

'*********************************************************
' ermittelt das Minimum zweier Zahlen
'*********************************************************
Function Min(a,b)
	If a < b Then
		Min = a
	Else
		Min = b
	End If
End Function

'*********************************************************
' Prfung, ob Verzeichnis folder existiert
'*********************************************************
Function FolderExists(folder)
   Dim fso
   Set fso = CreateObject("Scripting.FileSystemObject")
   FolderExists = fso.FolderExists(folder)
   set fso = nothing
End Function

'*********************************************************
' liefert Verzeichnis mit abschliessendem Backslash,
' Dateinamen und Erweiterung mit einleitendem Punkt
'*********************************************************
sub SplitPath(path, byref dirc, byref file, byref ext)
	dim fso
	Set fso = CreateObject("Scripting.FileSystemObject")
	dirc = fso.GetParentFolderName(path) & "\"
	file = fso.GetBaseName(path)
	ext = "." & fso.GetExtensionName(path)
	set fso = nothing
End Sub
